// Command.cpp: implementation of the CCommand class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "engine.h"
#include "ReMaic Studio.h"
#include "Command.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BOOL prevmov = FALSE;

void OrderList(CmdList& List)
{
	CmdList Copy;
	while (!List.IsEmpty())
	{
		Copy.AddTail(List.RemoveHead());
	}

	
	while (!Copy.IsEmpty())
	{
		float MinTime= 99999;
		POSITION MinPos;
		POSITION P = Copy.GetHeadPosition();
		while (P)
		{
			if (MinTime > Copy.GetAt(P).m_time)
			{
				MinTime = Copy.GetAt(P).m_time;
				MinPos = P;
			}
			Copy.GetNext(P);
		}

		List.AddTail(Copy.GetAt(MinPos));
		Copy.RemoveAt(MinPos);
	}

}


void CCommand::ReadLine(ifstream input)
{
	int i = 0;
	char buffer[800];
	char temp[800];
	char* ptr;
	char* pt2;
	long flags;
	float com_time;
	flags = input.flags();
	input.flags(0);
	do 
	{
		buffer[i] = '\255';
		input >> buffer[i];
		if (buffer[i] == '\255')
		{
			finished = TRUE;
			return;
		}
	}
	while (buffer[i++] != '\n' );
	buffer[i] = '\0';
	input.flags(flags);
	ptr = buffer + strlen(buffer)-1;
	while (*ptr == ' ' || *ptr == '\n' || *ptr == 0x0D)
		--ptr;
	ptr[1] = '\0';
	ptr = buffer;
	while (*ptr == ' ')
		ptr++;
	if (*ptr == '#' || *ptr == '\n' || ptr[1] == '\n')
		return; // comment or empty line 
	strcpy(temp,ptr);
	pt2 = temp;
	while (*pt2 != ' ')
		*pt2++;
	*pt2 = '\0';
	if (!*temp)
		return;
	com_time = (float)atof(temp);
	ptr = ++pt2;
	while (*ptr != ' ')
		ptr++;
	*ptr = '\0';


	// here goes the logical code and not the string analysing shit

	if (!strcmp(pt2,"stay") ||
		!strcmp(pt2,"move") ||
		!strcmp(pt2,"spin") ||
		!strcmp(pt2,"cut"))
	{
		if (!movement.IsEmpty() && movement.GetTail().end_time == 0)
		{
			movement.GetTail().end_time = com_time;
		}
		CCommand com;
		com.m_coord = ptr + 1;
		com.type = pt2;
		com.m_time = com_time;
		com.end_time = 0;
		movement.AddTail(com);
	}
	else if (!strcmp(pt2,"view") ||
			!strcmp(pt2,"turn") ||
			!strcmp(pt2,"pan"))
	{
		if (!target.IsEmpty() && target.GetTail().end_time == 0)
		{
			target.GetTail().end_time = com_time;
		}
		CCommand com;
		com.m_coord = ptr + 1;
		com.type = pt2;
		com.m_time = com_time;
		com.end_time = 0;
		target.AddTail(com);
	}
	else if (!strcmp(pt2,"roll") ||
			!strcmp(pt2,"lean"))
	{
		CCommand com;
		com.data = (float)atof (ptr + 1);
		com.type = pt2;
		com.m_time = com_time;
		com.end_time = 0;
		if (!roll.IsEmpty() && roll.GetTail().end_time == 0)
		{
			roll.GetTail().end_time = com_time;
			if ((roll.GetTail().data - com.data) > 180)
				com.data += 360;
			if ((roll.GetTail().data - com.data) < -180)
				com.data -= 360;
		}
		roll.AddTail(com);
	}
	else if (!strcmp(pt2,"palette")||
			!strcmp(pt2,"fade"))
	{
		CCommand com;
		com.R = com.G = com.B = com.data = 0;
		com.m_time = com_time;
		com.end_time = 0;
		com.type = pt2;
		char* c = ptr + 1;
        do
		{
			if (*c >= '0' && *c <= '9')
            {
				com.data = com.data * 10 + (*c - '0');
	        }
			if (*c == ' ')
            {
				com.R = com.G;
                com.G = com.B;
                com.B = com.data;
                com.data = 0;
            }
        }
        while (*c++);

		if (!palette.IsEmpty() && palette.GetTail().end_time == 0)
		{
			palette.GetTail().end_time = com_time;
		}
		palette.AddTail(com);
	}
	else if (!strcmp(pt2,"text"))
	{
		char buffer[800];
		CCommand com;
		com.m_time = com_time;
		char* c = ptr + 1;
		char* d = buffer;
		do ; while (*c++ != ' ');
		*(--c) = '\0';
		com.type = ptr + 1;
		do ; while (*c++ != '"');
		do
		{
			if (*c == '\\')
			{
				++c;
				if (*c=='\\')
					*d = '\\';
				else if (*c=='n')
					*d = '\n';
				else if (*c=='"')
					*d = '"';
			}
			else
				*d = *c;
			d++;c++;
		}
		while (*c != '"');
		*d = '\0';
		com.text = buffer;
		misc.AddTail(com);
	}
	else if (!strcmp(pt2,"subtitle"))
	{
		char buffer[800];
		CCommand com;
		com.m_time = com_time;
		char* c = ptr + 1;
		strcpy (buffer,"alias subtitle echo \"");
		char* d = buffer + strlen(buffer);
		com.type = "stufftext";
		do ; while (*c++ != '"');
		do
		{
			if (*c == '\\')
			{
				++c;
				if (*c=='\\')
					*d = '\\';
				else if (*c=='n')
					*d = '\n';
				else if (*c=='"')
					*d = '"';
			}
			else
				*d = *c;
			d++;c++;
		}
		while (*c != '"');
		*d = '\0';
		strcat (buffer,"\";\nprint_subtitle\n");
		com.text = buffer;
		misc.AddTail(com);
	}
	else if (!strcmp(pt2,"sound"))
	{
		CCommand com;
        com.m_time = com_time;
		com.end_time = 449;
		com.type = "sound";
        char* filename;
        filename = ptr+1;
        if (filename[0] != '\"')
        {
			if (filename[0] == 'p')
				com.end_time = 1;
            else
	            com.end_time = (float)atoi (filename+1);
			do
				filename++;
			while (*filename != '"');
		}
		filename++;
        char *c = filename;
		do
			c++;
		while (*c != '"');
		*c = '\0';
		c++;
        com.text = filename;
		com.text += ".wav";
		com.R = 1; // attenuation
		com.G = 1; // volume
		com.B = 0; // channel
		while (*c != '\0')
		{
			while (*c && *c != ' ')
				c++;
			if (*c)
				c++;
			switch (*c)
			{
			case 'a':
				com.R = (float)atof(c+1);
			break;
			case 'v':
				com.G = (float)atof(c+1);
			break;
			case 'c':
				com.B = (float)atof(c+1);
			break;
			}
		}
		misc.AddTail(com);
	}
	else if (!strcmp(pt2,"end"))
	{
		ptr++;
		if ((!strcmp(ptr,"move") || !strcmp(ptr,"spin"))&& !movement.IsEmpty())
		{
			movement.GetTail().end_time = com_time;
		}
		else if ((!strcmp(ptr,"pan") ||
				!strcmp(ptr,"turn"))
				&& !target.IsEmpty())
		{
			target.GetTail().end_time = com_time;
		}
		else if (!strcmp(ptr,"fade")
				&& !palette.IsEmpty())
		{
			palette.GetTail().end_time = com_time;
		}
		else if (!strcmp(ptr,"roll")
				&& !roll.IsEmpty())
		{
			roll.GetTail().end_time = com_time;
		}
	}
	else if (!strcmp(pt2,"eyes"))
	{
		ptr++;
		int Who;
		if (! *ptr)
		{
			Who = 1;
		}
		else
			Who = atoi (ptr);
		CCommand com;
		com.type = "eyes";
		com.m_time = com_time;
		com.data = (float)(Who*100);
		misc.AddTail(com);
	}
	else if (!strcmp(pt2,"timescale"))
	{
		ptr++;
		float Scale;
		Scale = (float)(1.0 / atof(ptr));
		CCommand com;
		com.type = "timescale";
		com.m_time = com_time;
		com.data = Scale;
		misc.AddTail(com);
	}
	else if (!strcmp(pt2,"qdqtimescale"))
	{
		ptr++;
		float Scale;
		Scale = (float)(1.0 / atof(ptr));
		CCommand com;
		com.type = "qdqtimescale";
		com.m_time = com_time;
		com.data = Scale;
		misc.AddTail(com);
	};
}
