#include "engine.h"
#include "remaic studio.h"
#define TRIGNUM 100
int triggers[TRIGNUM][3][3];
int cur_trig;
float old_time = 0;
BOOL visible[TRIGNUM][TRIGNUM];
BOOL exists(CString filename);
void Sort(int& a,int& b)
{
	if (a>b)
	{
		int c = a;
		a = b;
		b = c;
	}
}
BOOL Inside (int trig, float* coord)
{
	for (int i = 0; i < 3; i++)
		if (coord[i] < triggers[trig][1][i] ||
			coord[i] > triggers[trig][2][i])
			return FALSE;
		return TRUE;
}

void ReadTriggers(ifstream log)
{
	char a[80];
	int num,vis,i,j;
	for (i = 0; i < TRIGNUM; i++)
	{
		for (j = 0; j < 3; j++)
			for (int k = 0; k < 3; k++)
				triggers[i][j][k] = 0;
		for (j = 0; j < TRIGNUM; j++)
			visible[i][j] = FALSE; // you see NOTHING
	}

	while (strcmp(a,"EMPTY"))
	{
		do
		{
			strcpy(a,"EMPTY");
			log >> a;
		}
		while (strcmp(a,"---START---")&&strcmp(a,"EMPTY"));
		if (strcmp(a,"EMPTY"))
		{
			log >> a;
			do
			{
				num = atoi (a);
				for ( i = 0; i < 3; i++)
					for ( j = 0; j < 3; j++)
						log >> triggers[num][i][j];
				Sort(triggers[num][1][0],
					 triggers[num][2][0]);
				Sort(triggers[num][1][1],
					 triggers[num][2][1]);
				Sort(triggers[num][1][2],
					 triggers[num][2][2]);
				do
				{
					log >> vis;
					visible[num][vis] = TRUE;
					visible[vis][num] = TRUE;
				} while (vis);
				log >> a;
			} while (strcmp(a,"---END---"));
		}
	}
}

void CheckTrigger(ofstream script)
{

	if (cur_trig && Inside (cur_trig, positions[PLAYER].GetHead().origin))
		return; // current trigger still active;
	for (int i = 1;i<TRIGNUM;i++)
	{
		if (!positions[PLAYER].IsEmpty() && Inside (i, positions[PLAYER].GetHead().origin))
		{
			if (!cur_trig)
			{
				script << "0 stay " <<
					triggers[i][0][0] << " " <<
					triggers[i][0][1] << " " <<
					triggers[i][0][2] << endl;
			}
			else 
			{
				if (cur_trig && visible[cur_trig][i])
				{
					script << old_time << " move " <<
						triggers[i][0][0] << " " <<
						triggers[i][0][1] << " " <<
						triggers[i][0][2] << endl;
/*					if (dialog->m_pan)
					{
						script << old_time << " pan " << positions[2].GetHead().origin[0] << " " <<
						 positions[2].GetHead().origin[1] << " " <<
						 positions[2].GetHead().origin[2] << endl;

						script << cur_time - 0.001 << " end pan" << endl;
					}*/

					script << cur_time - 0.001 << " end move" << endl;
				}
				else
				{
					script << cur_time << " stay ";
					script << triggers[i][0][0] << " " <<
								triggers[i][0][1] << " " <<
								triggers[i][0][2] << endl;
					POSITION Pos = positions[PLAYER].GetHeadPosition();
					positions[PLAYER].GetNext(Pos);
					EntPos H = positions[PLAYER].GetAt(Pos);
					if (dialog->m_pan)
					{
						script << old_time << " pan p" << endl;
						script << "# hello "<< endl;
						script << cur_time << " view " << H.origin[0] << " " <<
						 H.origin[1] << " " <<
						 H.origin[2] << endl;
					}
				}
			}
			old_time = cur_time;
			cur_trig = i;
		} 
	}
}
void generate(char* demo,char* scr)
{
	ifstream source;
	ifstream log;
	ofstream script;
	char c;
	char logfile[30];
	script.open(scr);//,ios::binary);

	source.open(demo,ios::binary);
	source.flags(0);
	do 
		source >> c;
	while (c != '\n');
	CBlock src;
	CBlock dst;
	do
	{
		src.Read(source);
		Process(src,dst);
	} while (!ReadModels);

	interest[1] = TRUE;

	strcpy(logfile,models[1]+5);

	*strchr(logfile,'.') = '\0';
	strcat(logfile,".log");

	script << "0 view p"<<endl;

	if (!exists(logfile))
	{
		dialog->MessageBox(
			"No camera disposition file exists for this map. Using chasecam instead.",
			"Warning",MB_ICONEXCLAMATION | MB_OK);
		script << "0 stay p" << endl;
		script << "1.5 stay p~0.3 p~0.3 p+30" << endl;
		script.close();
		return;
	}
	log.open(logfile);
	ReadTriggers(log);

	src.Read(source);
	while (strcmp(src.m_buffer,"ABCDEFG"))
	{
		Process(src,dst);
		CheckTrigger(script);
		src.Read(source);
	}
	source.close();
	script.close();
	log.close();
}